//Very Tiny Square
//version 1
//By Sparr
//(c) 2004 Clarence Risher
//sparr0@gmail.com
//Released under the GNU GPL, latest version available at http://www.gnu.org/licenses/gpl.txt
//Inspired by SquareZ by Jimmy Mardell

#define NOTSOTINY

#ifdef NOTSOTINY
#define LEFT 0
#define TOP 100
#define BIGLEFT 48
#define BIGTOP 8
#else
#define LEFT 71
#define TOP 31
#endif

#define NUMPIECES 42

#define NO_CALC_DETECT
#include <tigcclib.h>
#undef __need_in_use_bit
#define __need_in_use_bit ((void)0)
#include "extgraph.h"

unsigned short pieces[NUMPIECES] = \
{ \
0b1110000000000000, \
0b0110010000000000, \
0b1110001000000000, \
0b1110100000000000, \
0b1110010000000000, \
0b0110110000000000, \
0b1100011000000000, \
0b1110110000000000, \
0b1110011000000000, \
0b1110100010000000, \
0b1110101000000000, \
0b0010111010000000, \
0b1000111010000000, \
0b0100111010000000, \
0b0100111000100000, \
0b1110111000000000, \
0b0010111011000000, \
0b0100111011000000, \
0b1000111011000000, \
0b1000111010100000, \
0b0100111010100000, \
0b0010111010100000, \
0b1000111001100000, \
0b0100111001100000, \
0b0010111001100000, \
0b1110101010000000, \
0b1000101011100000, \
0b1100100011100000, \
0b1110100011000000, \
0b1110110010000000, \
0b0010111011100000, \
0b1000111011100000, \
0b0100111011100000, \
0b0110011011100000, \
0b1100110011100000, \
0b0110111010100000, \
0b1100111010100000, \
0b0110111011000000, \
0b1010101011100000, \
0b0110111011100000, \
0b1010111011100000, \
0b1100111011100000 \
};

//piece sprite
register unsigned short ps asm("d6");
//piece x and y position
register short ppx asm("a4"),ppy asm("a3");

//XOR a screen pixel
void XORPix(unsigned short x,unsigned short y) {
//	*(char*)(LCD_MEM+y*30+x/8)^=128>>(x&7);
	EXT_XORPIX(LCD_MEM,x,y);
}

//XOR a 4x4 sprite onto the display
void XORSprite(unsigned short x,unsigned short y,unsigned short sprite) {
	short sx,sy;
	for(sx=4;sx--;)
		for(sy=4;sy--;)
			if(((sprite<<(sy*4))<<sx)&(1<<15)) XORPix(x+sx,y+sy);
}

//check if the current piece collides with something on the screen
int collide() {
	short sx;
	for(sx=15;sx--;)
		if(
			((ps<<sx)&(1<<15))
			&&
			EXT_GETPIX(LCD_MEM,ppx+sx%4,ppy+sx/4)
		)
			return 1;
	return 0;
}

//Draw (or erase) the piece at its location.
void XORPiece() {
#ifdef NOTSOTINY
	//draw the piece on the big board
	short sx,sy;
	for(sx=4;sx--;)
		for(sy=4;sy--;)
			if(((ps<<(sy*4))<<sx)&(1<<15)) XORSprite(
			(ppx+sx-LEFT)*4+BIGLEFT,
			(ppy+sy-TOP)*4+BIGTOP,
			0b1111110110111111);
#endif
	//draw the piece on the tiny board
	XORSprite(ppx,ppy,ps);
}

//rotate the top left 3x3 subsprite of ps num*90 degrees clockwise
void rotate() {
	short ts=0,x;
	for(x=16;x--;)
		ts|=((ps>>(char[]){0,1,2,3,4,13,9,5,8,14,10,6,12,15,11,7}[x])&1)<<x;
	ps=ts;
}

// Main Function
void _main(void)
{
	char *virtual=malloc(LCD_SIZE);

	short oldOSInitKeyInitDelay=OSInitKeyInitDelay(64);
	short oldOSInitBetweenKeyDelay=OSInitBetweenKeyDelay(32);

	short x,y;

	restart:

	for(x=LCD_SIZE;x--;)
		*(char*)(LCD_MEM+x)=0;

#ifdef NOTSOTINY
	XORSprite(BIGLEFT+12,BIGTOP+12,0b0001000100011111);
#endif
	for(x=17;x---1;) {
#ifdef NOTSOTINY
		XORSprite(BIGLEFT+x*4,BIGTOP,0xFFFF);
		XORSprite(BIGLEFT+x*4,BIGTOP+17*4,0xFFFF);
		XORSprite(BIGLEFT,BIGTOP+x*4,0xFFFF);
		XORSprite(BIGLEFT+17*4,BIGTOP+x*4,0xFFFF);
#endif
		XORPix(LEFT+x,TOP);
		XORPix(LEFT+x,TOP+17);
		XORPix(LEFT,TOP+x);
		XORPix(LEFT+17,TOP+x);
	}

	//Main loop, make new piece, check for game over, display scores
	while(1){
		ps=pieces[((ps>>5)+(*(unsigned char*)0x600017))%NUMPIECES]; // somewhat random number
		ppx=LEFT+1;
		ppy=TOP+1;
		if(collide()) break;

		XORPiece();
		while(1) {
			if(kbhit()) {
				XORPiece();
				unsigned short key=ngetchx();
				if(key==KEY_RIGHT) {
					ppx++;
				  ppx-=collide();
				}
				if(key==KEY_LEFT) {
					ppx--;
					ppx+=collide();
				}
				if(key==KEY_UP) {
					ppy--;
					ppy+=collide();
				}
				if(key==KEY_DOWN)
					ppy++;
					ppy-=collide();
				if(key==KEY_F1) {
					rotate();
					rotate();
					rotate();
					if(collide()) rotate();
				}
				if(key==KEY_F2) {
					rotate();
					if(collide()) {
						rotate();
						rotate();
						rotate();
					}
				}
				if(key==KEY_F3) {
					XORPiece();
					break;
				}
				if(key==KEY_ESC)
				  goto quit;
				XORPiece();
			}
		}

		for(x=LCD_SIZE;x--;)
			*(virtual+x)=0;

		short s;
		for(x=LEFT+1;x<LEFT+17-2;x++) {
			for(y=TOP+1;y<TOP+17-2;y++) {

				for(s=9;s--;)
					if(!(EXT_GETPIX(LCD_MEM,x+s%3,y+s/3))) break;
				if(s==-1)
					for(s=9;s--;)
						EXT_SETPIX(virtual,x+s%3,y+s/3);
			}
		}
		for(x=LCD_SIZE;x--;) {
			*(char*)(LCD_MEM+x)^=*(virtual+x);
#ifdef NOTSOTINY
			if (*(virtual+x)) {
				for(s=8;s--;) {
					if ((*(virtual+x))&(128>>s)) {
						XORSprite((((x%30)*8+s)-LEFT)*4+BIGLEFT,(x/30-TOP)*4+BIGTOP,0b1111110110111111);
					}
				}
			}
#endif
		}
	}

//	if(DlgMessage("Game Over","Play Again?",BT_YES,BT_NO)==KEY_ENTER)
//		goto restart;

	quit:

	OSInitKeyInitDelay(oldOSInitKeyInitDelay);
	OSInitBetweenKeyDelay(oldOSInitBetweenKeyDelay);
}
